Index: lemon/bfs.h
===================================================================
--- lemon/bfs.h	(revision 305)
+++ lemon/bfs.h	(revision 220)
@@ -789,59 +725,60 @@
                                   G->source((*_pred)[v]); }
 
-    ///\brief Returns a const reference to the node map that stores the
-    /// distances of the nodes.
-    ///
-    ///Returns a const reference to the node map that stores the distances
-    ///of the nodes calculated by the algorithm.
-    ///
-    ///\pre Either \ref run() or \ref init()
-    ///must be called before using this function.
+    ///Returns a reference to the NodeMap of distances.
+
+    ///Returns a reference to the NodeMap of distances.
+    ///\pre Either \ref run() or \ref init() must
+    ///be called before using this function.
     const DistMap &distMap() const { return *_dist;}
 
-    ///\brief Returns a const reference to the node map that stores the
-    ///predecessor arcs.
-    ///
-    ///Returns a const reference to the node map that stores the predecessor
-    ///arcs, which form the shortest path tree.
-    ///
+    ///Returns a reference to the shortest path tree map.
+
+    ///Returns a reference to the NodeMap of the arcs of the
+    ///shortest path tree.
     ///\pre Either \ref run() or \ref init()
     ///must be called before using this function.
     const PredMap &predMap() const { return *_pred;}
 
-    ///Checks if a node is reachable from the root(s).
-
-    ///Returns \c true if \c v is reachable from the root(s).
+    ///Checks if a node is reachable from the root.
+
+    ///Returns \c true if \c v is reachable from the root.
+    ///\warning The source nodes are indicated as unreached.
     ///\pre Either \ref run() or \ref start()
     ///must be called before using this function.
-    bool reached(Node v) const { return (*_reached)[v]; }
+    ///
+    bool reached(Node v) { return (*_reached)[v]; }
 
     ///@}
   };
 
-  ///Default traits class of bfs() function.
-
-  ///Default traits class of bfs() function.
+  ///Default traits class of Bfs function.
+
+  ///Default traits class of Bfs function.
   ///\tparam GR Digraph type.
   template<class GR>
   struct BfsWizardDefaultTraits
   {
-    ///The type of the digraph the algorithm runs on.
+    ///The digraph type the algorithm runs on.
     typedef GR Digraph;
-
-    ///\brief The type of the map that stores the predecessor
+    ///\brief The type of the map that stores the last
     ///arcs of the shortest paths.
     ///
-    ///The type of the map that stores the predecessor
+    ///The type of the map that stores the last
     ///arcs of the shortest paths.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<typename Digraph::Arc> PredMap;
+    ///
+    typedef NullMap<typename Digraph::Node,typename GR::Arc> PredMap;
     ///Instantiates a PredMap.
 
-    ///This function instantiates a PredMap.
-    ///\param g is the digraph, to which we would like to define the
-    ///PredMap.
-    static PredMap *createPredMap(const Digraph &g)
-    {
-      return new PredMap(g);
+    ///This function instantiates a \ref PredMap.
+    ///\param g is the digraph, to which we would like to define the PredMap.
+    ///\todo The digraph alone may be insufficient to initialize
+#ifdef DOXYGEN
+    static PredMap *createPredMap(const GR &g)
+#else
+    static PredMap *createPredMap(const GR &)
+#endif
+    {
+      return new PredMap();
     }
 
@@ -850,63 +787,61 @@
     ///The type of the map that indicates which nodes are processed.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    ///By default it is a NullMap.
+    ///\todo named parameter to set this type, function to read and write.
     typedef NullMap<typename Digraph::Node,bool> ProcessedMap;
     ///Instantiates a ProcessedMap.
 
-    ///This function instantiates a ProcessedMap.
+    ///This function instantiates a \ref ProcessedMap.
     ///\param g is the digraph, to which
-    ///we would like to define the ProcessedMap.
+    ///we would like to define the \ref ProcessedMap
 #ifdef DOXYGEN
-    static ProcessedMap *createProcessedMap(const Digraph &g)
+    static ProcessedMap *createProcessedMap(const GR &g)
 #else
-    static ProcessedMap *createProcessedMap(const Digraph &)
+    static ProcessedMap *createProcessedMap(const GR &)
 #endif
     {
       return new ProcessedMap();
     }
-
     ///The type of the map that indicates which nodes are reached.
 
     ///The type of the map that indicates which nodes are reached.
-    ///It must meet the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///\todo named parameter to set this type, function to read and write.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
     ///Instantiates a ReachedMap.
 
-    ///This function instantiates a ReachedMap.
-    ///\param g is the digraph, to which
-    ///we would like to define the ReachedMap.
-    static ReachedMap *createReachedMap(const Digraph &g)
-    {
-      return new ReachedMap(g);
-    }
-
-    ///The type of the map that stores the distances of the nodes.
-
-    ///The type of the map that stores the distances of the nodes.
+    ///This function instantiates a \ref ReachedMap.
+    ///\param G is the digraph, to which
+    ///we would like to define the \ref ReachedMap.
+    static ReachedMap *createReachedMap(const GR &G)
+    {
+      return new ReachedMap(G);
+    }
+    ///The type of the map that stores the dists of the nodes.
+
+    ///The type of the map that stores the dists of the nodes.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<int> DistMap;
+    ///
+    typedef NullMap<typename Digraph::Node,int> DistMap;
     ///Instantiates a DistMap.
 
-    ///This function instantiates a DistMap.
+    ///This function instantiates a \ref DistMap.
     ///\param g is the digraph, to which we would like to define
-    ///the DistMap
-    static DistMap *createDistMap(const Digraph &g)
-    {
-      return new DistMap(g);
-    }
-
-    ///The type of the shortest paths.
-
-    ///The type of the shortest paths.
-    ///It must meet the \ref concepts::Path "Path" concept.
-    typedef lemon::Path<Digraph> Path;
+    ///the \ref DistMap
+#ifdef DOXYGEN
+    static DistMap *createDistMap(const GR &g)
+#else
+    static DistMap *createDistMap(const GR &)
+#endif
+    {
+      return new DistMap();
+    }
   };
 
-  /// Default traits class used by BfsWizard
+  /// Default traits used by \ref BfsWizard
 
   /// To make it easier to use Bfs algorithm
-  /// we have created a wizard class.
+  ///we have created a wizard class.
   /// This \ref BfsWizard class needs default traits,
-  /// as well as the \ref Bfs class.
+  ///as well as the \ref Bfs class.
   /// The \ref BfsWizardBase is a class to be the default traits of the
   /// \ref BfsWizard class.
@@ -917,21 +852,19 @@
     typedef BfsWizardDefaultTraits<GR> Base;
   protected:
-    //The type of the nodes in the digraph.
+    /// Type of the nodes in the digraph.
     typedef typename Base::Digraph::Node Node;
 
-    //Pointer to the digraph the algorithm runs on.
+    /// Pointer to the underlying digraph.
     void *_g;
-    //Pointer to the map of reached nodes.
+    ///Pointer to the map of reached nodes.
     void *_reached;
-    //Pointer to the map of processed nodes.
+    ///Pointer to the map of processed nodes.
     void *_processed;
-    //Pointer to the map of predecessors arcs.
+    ///Pointer to the map of predecessors arcs.
     void *_pred;
-    //Pointer to the map of distances.
+    ///Pointer to the map of distances.
     void *_dist;
-    //Pointer to the shortest path to the target node.
-    void *_path;
-    //Pointer to the distance of the target node.
-    int *_di;
+    ///Pointer to the source node.
+    Node _source;
 
     public:
@@ -939,28 +872,40 @@
 
     /// This constructor does not require parameters, therefore it initiates
-    /// all of the attributes to \c 0.
+    /// all of the attributes to default values (0, INVALID).
     BfsWizardBase() : _g(0), _reached(0), _processed(0), _pred(0),
-                      _dist(0), _path(0), _di(0) {}
+                           _dist(0), _source(INVALID) {}
 
     /// Constructor.
 
-    /// This constructor requires one parameter,
-    /// others are initiated to \c 0.
-    /// \param g The digraph the algorithm runs on.
-    BfsWizardBase(const GR &g) :
+    /// This constructor requires some parameters,
+    /// listed in the parameters list.
+    /// Others are initiated to 0.
+    /// \param g is the initial value of  \ref _g
+    /// \param s is the initial value of  \ref _source
+    BfsWizardBase(const GR &g, Node s=INVALID) :
       _g(reinterpret_cast<void*>(const_cast<GR*>(&g))),
-      _reached(0), _processed(0), _pred(0), _dist(0),  _path(0), _di(0) {}
+      _reached(0), _processed(0), _pred(0), _dist(0), _source(s) {}
 
   };
 
-  /// Auxiliary class for the function-type interface of BFS algorithm.
-
-  /// This auxiliary class is created to implement the
-  /// \ref bfs() "function-type interface" of \ref Bfs algorithm.
-  /// It does not have own \ref run() method, it uses the functions
-  /// and features of the plain \ref Bfs.
+  /// A class to make the usage of Bfs algorithm easier
+
+  /// This class is created to make it easier to use Bfs algorithm.
+  /// It uses the functions and features of the plain \ref Bfs,
+  /// but it is much simpler to use it.
   ///
-  /// This class should only be used through the \ref bfs() function,
-  /// which makes it easier to use the algorithm.
+  /// Simplicity means that the way to change the types defined
+  /// in the traits class is based on functions that returns the new class
+  /// and not on templatable built-in classes.
+  /// When using the plain \ref Bfs
+  /// the new class with the modified type comes from
+  /// the original class by using the ::
+  /// operator. In the case of \ref BfsWizard only
+  /// a function have to be called and it will
+  /// return the needed class.
+  ///
+  /// It does not have own \ref run method. When its \ref run method is called
+  /// it initiates a plain \ref Bfs class, and calls the \ref Bfs::run
+  /// method of it.
   template<class TR>
   class BfsWizard : public TR
@@ -968,26 +913,28 @@
     typedef TR Base;
 
-    ///The type of the digraph the algorithm runs on.
+    ///The type of the underlying digraph.
     typedef typename TR::Digraph Digraph;
-
+    //\e
     typedef typename Digraph::Node Node;
+    //\e
     typedef typename Digraph::NodeIt NodeIt;
+    //\e
     typedef typename Digraph::Arc Arc;
+    //\e
     typedef typename Digraph::OutArcIt OutArcIt;
 
-    ///\brief The type of the map that stores the predecessor
+    ///\brief The type of the map that stores
+    ///the reached nodes
+    typedef typename TR::ReachedMap ReachedMap;
+    ///\brief The type of the map that stores
+    ///the processed nodes
+    typedef typename TR::ProcessedMap ProcessedMap;
+    ///\brief The type of the map that stores the last
     ///arcs of the shortest paths.
     typedef typename TR::PredMap PredMap;
-    ///\brief The type of the map that stores the distances of the nodes.
+    ///The type of the map that stores the dists of the nodes.
     typedef typename TR::DistMap DistMap;
-    ///\brief The type of the map that indicates which nodes are reached.
-    typedef typename TR::ReachedMap ReachedMap;
-    ///\brief The type of the map that indicates which nodes are processed.
-    typedef typename TR::ProcessedMap ProcessedMap;
-    ///The type of the shortest paths
-    typedef typename TR::Path Path;
 
   public:
-
     /// Constructor.
     BfsWizard() : TR() {}
@@ -997,7 +944,6 @@
     /// Constructor that requires parameters.
     /// These parameters will be the default values for the traits class.
-    /// \param g The digraph the algorithm runs on.
-    BfsWizard(const Digraph &g) :
-      TR(g) {}
+    BfsWizard(const Digraph &g, Node s=INVALID) :
+      TR(g,s) {}
 
     ///Copy constructor
@@ -1006,157 +952,123 @@
     ~BfsWizard() {}
 
-    ///Runs BFS algorithm from the given source node.
-
-    ///This method runs BFS algorithm from node \c s
-    ///in order to compute the shortest path to each node.
+    ///Runs Bfs algorithm from a given node.
+
+    ///Runs Bfs algorithm from a given node.
+    ///The node can be given by the \ref source function.
+    void run()
+    {
+      if(Base::_source==INVALID) throw UninitializedParameter();
+      Bfs<Digraph,TR> alg(*reinterpret_cast<const Digraph*>(Base::_g));
+      if(Base::_reached)
+        alg.reachedMap(*reinterpret_cast<ReachedMap*>(Base::_reached));
+      if(Base::_processed)
+        alg.processedMap(*reinterpret_cast<ProcessedMap*>(Base::_processed));
+      if(Base::_pred)
+        alg.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
+      if(Base::_dist)
+        alg.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
+      alg.run(Base::_source);
+    }
+
+    ///Runs Bfs algorithm from the given node.
+
+    ///Runs Bfs algorithm from the given node.
+    ///\param s is the given source.
     void run(Node s)
     {
-      Bfs<Digraph,TR> alg(*reinterpret_cast<const Digraph*>(Base::_g));
-      if (Base::_pred)
-        alg.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
-      if (Base::_dist)
-        alg.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
-      if (Base::_reached)
-        alg.reachedMap(*reinterpret_cast<ReachedMap*>(Base::_reached));
-      if (Base::_processed)
-        alg.processedMap(*reinterpret_cast<ProcessedMap*>(Base::_processed));
-      if (s!=INVALID)
-        alg.run(s);
-      else
-        alg.run();
-    }
-
-    ///Finds the shortest path between \c s and \c t.
-
-    ///This method runs BFS algorithm from node \c s
-    ///in order to compute the shortest path to node \c t
-    ///(it stops searching when \c t is processed).
-    ///
-    ///\return \c true if \c t is reachable form \c s.
-    bool run(Node s, Node t)
-    {
-      Bfs<Digraph,TR> alg(*reinterpret_cast<const Digraph*>(Base::_g));
-      if (Base::_pred)
-        alg.predMap(*reinterpret_cast<PredMap*>(Base::_pred));
-      if (Base::_dist)
-        alg.distMap(*reinterpret_cast<DistMap*>(Base::_dist));
-      if (Base::_reached)
-        alg.reachedMap(*reinterpret_cast<ReachedMap*>(Base::_reached));
-      if (Base::_processed)
-        alg.processedMap(*reinterpret_cast<ProcessedMap*>(Base::_processed));
-      alg.run(s,t);
-      if (Base::_path)
-        *reinterpret_cast<Path*>(Base::_path) = alg.path(t);
-      if (Base::_di)
-        *Base::_di = alg.dist(t);
-      return alg.reached(t);
-    }
-
-    ///Runs BFS algorithm to visit all nodes in the digraph.
-
-    ///This method runs BFS algorithm in order to compute
-    ///the shortest path to each node.
-    void run()
-    {
-      run(INVALID);
+      Base::_source=s;
+      run();
     }
 
     template<class T>
-    struct SetPredMapBase : public Base {
+    struct DefPredMapBase : public Base {
       typedef T PredMap;
       static PredMap *createPredMap(const Digraph &) { return 0; };
-      SetPredMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting PredMap object.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for setting PredMap object.
+      DefPredMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting PredMap
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting PredMap
+    ///
     template<class T>
-    BfsWizard<SetPredMapBase<T> > predMap(const T &t)
+    BfsWizard<DefPredMapBase<T> > predMap(const T &t)
     {
       Base::_pred=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return BfsWizard<SetPredMapBase<T> >(*this);
-    }
+      return BfsWizard<DefPredMapBase<T> >(*this);
+    }
+
 
     template<class T>
-    struct SetReachedMapBase : public Base {
+    struct DefReachedMapBase : public Base {
       typedef T ReachedMap;
       static ReachedMap *createReachedMap(const Digraph &) { return 0; };
-      SetReachedMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting ReachedMap object.
-    ///
-    /// \ref named-func-param "Named parameter"
-    ///for setting ReachedMap object.
+      DefReachedMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting ReachedMap
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting ReachedMap
+    ///
     template<class T>
-    BfsWizard<SetReachedMapBase<T> > reachedMap(const T &t)
+    BfsWizard<DefReachedMapBase<T> > reachedMap(const T &t)
     {
       Base::_reached=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return BfsWizard<SetReachedMapBase<T> >(*this);
-    }
+      return BfsWizard<DefReachedMapBase<T> >(*this);
+    }
+
 
     template<class T>
-    struct SetDistMapBase : public Base {
+    struct DefProcessedMapBase : public Base {
+      typedef T ProcessedMap;
+      static ProcessedMap *createProcessedMap(const Digraph &) { return 0; };
+      DefProcessedMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting ProcessedMap
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting ProcessedMap
+    ///
+    template<class T>
+    BfsWizard<DefProcessedMapBase<T> > processedMap(const T &t)
+    {
+      Base::_processed=reinterpret_cast<void*>(const_cast<T*>(&t));
+      return BfsWizard<DefProcessedMapBase<T> >(*this);
+    }
+
+
+    template<class T>
+    struct DefDistMapBase : public Base {
       typedef T DistMap;
       static DistMap *createDistMap(const Digraph &) { return 0; };
-      SetDistMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting DistMap object.
-    ///
-    /// \ref named-func-param "Named parameter"
-    ///for setting DistMap object.
+      DefDistMapBase(const TR &b) : TR(b) {}
+    };
+
+    ///\brief \ref named-templ-param "Named parameter"
+    ///function for setting DistMap type
+    ///
+    /// \ref named-templ-param "Named parameter"
+    ///function for setting DistMap type
+    ///
     template<class T>
-    BfsWizard<SetDistMapBase<T> > distMap(const T &t)
+    BfsWizard<DefDistMapBase<T> > distMap(const T &t)
     {
       Base::_dist=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return BfsWizard<SetDistMapBase<T> >(*this);
-    }
-
-    template<class T>
-    struct SetProcessedMapBase : public Base {
-      typedef T ProcessedMap;
-      static ProcessedMap *createProcessedMap(const Digraph &) { return 0; };
-      SetProcessedMapBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for setting ProcessedMap object.
-    ///
-    /// \ref named-func-param "Named parameter"
-    ///for setting ProcessedMap object.
-    template<class T>
-    BfsWizard<SetProcessedMapBase<T> > processedMap(const T &t)
-    {
-      Base::_processed=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return BfsWizard<SetProcessedMapBase<T> >(*this);
-    }
-
-    template<class T>
-    struct SetPathBase : public Base {
-      typedef T Path;
-      SetPathBase(const TR &b) : TR(b) {}
-    };
-    ///\brief \ref named-func-param "Named parameter"
-    ///for getting the shortest path to the target node.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for getting the shortest path to the target node.
-    template<class T>
-    BfsWizard<SetPathBase<T> > path(const T &t)
-    {
-      Base::_path=reinterpret_cast<void*>(const_cast<T*>(&t));
-      return BfsWizard<SetPathBase<T> >(*this);
-    }
-
-    ///\brief \ref named-func-param "Named parameter"
-    ///for getting the distance of the target node.
-    ///
-    ///\ref named-func-param "Named parameter"
-    ///for getting the distance of the target node.
-    BfsWizard dist(const int &d)
-    {
-      Base::_di=const_cast<int*>(&d);
+      return BfsWizard<DefDistMapBase<T> >(*this);
+    }
+
+    /// Sets the source node, from which the Bfs algorithm runs.
+
+    /// Sets the source node, from which the Bfs algorithm runs.
+    /// \param s is the source node.
+    BfsWizard<TR> &source(Node s)
+    {
+      Base::_source=s;
       return *this;
     }
@@ -1164,18 +1076,16 @@
   };
 
-  ///Function-type interface for BFS algorithm.
+  ///Function type interface for Bfs algorithm.
 
   /// \ingroup search
-  ///Function-type interface for BFS algorithm.
+  ///Function type interface for Bfs algorithm.
   ///
-  ///This function also has several \ref named-func-param "named parameters",
+  ///This function also has several
+  ///\ref named-templ-func-param "named parameters",
   ///they are declared as the members of class \ref BfsWizard.
-  ///The following examples show how to use these parameters.
+  ///The following
+  ///example shows how to use these parameters.
   ///\code
-  ///  // Compute shortest path from node s to each node
-  ///  bfs(g).predMap(preds).distMap(dists).run(s);
-  ///
-  ///  // Compute shortest path from s to t
-  ///  bool reached = bfs(g).path(p).dist(d).run(s,t);
+  ///  bfs(g,source).predMap(preds).run();
   ///\endcode
   ///\warning Don't forget to put the \ref BfsWizard::run() "run()"
@@ -1185,14 +1095,14 @@
   template<class GR>
   BfsWizard<BfsWizardBase<GR> >
-  bfs(const GR &digraph)
+  bfs(const GR &g,typename GR::Node s=INVALID)
   {
-    return BfsWizard<BfsWizardBase<GR> >(digraph);
+    return BfsWizard<BfsWizardBase<GR> >(g,s);
   }
 
 #ifdef DOXYGEN
-  /// \brief Visitor class for BFS.
+  /// \brief Visitor class for bfs.
   ///
   /// This class defines the interface of the BfsVisit events, and
-  /// it could be the base of a real visitor class.
+  /// it could be the base of a real Visitor class.
   template <typename _Digraph>
   struct BfsVisitor {
@@ -1200,27 +1110,27 @@
     typedef typename Digraph::Arc Arc;
     typedef typename Digraph::Node Node;
-    /// \brief Called for the source node(s) of the BFS.
-    ///
-    /// This function is called for the source node(s) of the BFS.
-    void start(const Node& node) {}
-    /// \brief Called when a node is reached first time.
-    ///
-    /// This function is called when a node is reached first time.
+    /// \brief Called when the arc reach a node.
+    ///
+    /// It is called when the bfs find an arc which target is not
+    /// reached yet.
+    void discover(const Arc& arc) {}
+    /// \brief Called when the node reached first time.
+    ///
+    /// It is Called when the node reached first time.
     void reach(const Node& node) {}
-    /// \brief Called when a node is processed.
-    ///
-    /// This function is called when a node is processed.
-    void process(const Node& node) {}
-    /// \brief Called when an arc reaches a new node.
-    ///
-    /// This function is called when the BFS finds an arc whose target node
-    /// is not reached yet.
-    void discover(const Arc& arc) {}
-    /// \brief Called when an arc is examined but its target node is
+    /// \brief Called when the arc examined but target of the arc
     /// already discovered.
     ///
-    /// This function is called when an arc is examined but its target node is
+    /// It called when the arc examined but the target of the arc
     /// already discovered.
     void examine(const Arc& arc) {}
+    /// \brief Called for the source node of the bfs.
+    ///
+    /// It is called for the source node of the bfs.
+    void start(const Node& node) {}
+    /// \brief Called when the node processed.
+    ///
+    /// It is Called when the node processed.
+    void process(const Node& node) {}
   };
 #else
@@ -1230,9 +1140,9 @@
     typedef typename Digraph::Arc Arc;
     typedef typename Digraph::Node Node;
+    void discover(const Arc&) {}
+    void reach(const Node&) {}
+    void examine(const Arc&) {}
     void start(const Node&) {}
-    void reach(const Node&) {}
     void process(const Node&) {}
-    void discover(const Arc&) {}
-    void examine(const Arc&) {}
 
     template <typename _Visitor>
@@ -1241,9 +1151,9 @@
         Arc arc;
         Node node;
+        visitor.discover(arc);
+        visitor.reach(node);
+        visitor.examine(arc);
         visitor.start(node);
-        visitor.reach(node);
         visitor.process(node);
-        visitor.discover(arc);
-        visitor.examine(arc);
       }
       _Visitor& visitor;
@@ -1255,9 +1165,9 @@
   ///
   /// Default traits class of BfsVisit class.
-  /// \tparam _Digraph The type of the digraph the algorithm runs on.
+  /// \tparam _Digraph Digraph type.
   template<class _Digraph>
   struct BfsVisitDefaultTraits {
 
-    /// \brief The type of the digraph the algorithm runs on.
+    /// \brief The digraph type the algorithm runs on.
     typedef _Digraph Digraph;
 
@@ -1265,12 +1175,13 @@
     ///
     /// The type of the map that indicates which nodes are reached.
-    /// It must meet the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    /// It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    /// \todo named parameter to set this type, function to read and write.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
 
     /// \brief Instantiates a ReachedMap.
     ///
-    /// This function instantiates a ReachedMap.
+    /// This function instantiates a \ref ReachedMap.
     /// \param digraph is the digraph, to which
-    /// we would like to define the ReachedMap.
+    /// we would like to define the \ref ReachedMap.
     static ReachedMap *createReachedMap(const Digraph &digraph) {
       return new ReachedMap(digraph);
@@ -1281,5 +1192,5 @@
   /// \ingroup search
   ///
-  /// \brief %BFS algorithm class with visitor interface.
+  /// \brief %BFS Visit algorithm class.
   ///
   /// This class provides an efficient implementation of the %BFS algorithm
@@ -1288,24 +1199,19 @@
   /// The %BfsVisit class provides an alternative interface to the Bfs
   /// class. It works with callback mechanism, the BfsVisit object calls
-  /// the member functions of the \c Visitor class on every BFS event.
+  /// on every bfs event the \c Visitor class member functions.
   ///
-  /// This interface of the BFS algorithm should be used in special cases
-  /// when extra actions have to be performed in connection with certain
-  /// events of the BFS algorithm. Otherwise consider to use Bfs or bfs()
-  /// instead.
-  ///
-  /// \tparam _Digraph The type of the digraph the algorithm runs on.
+  /// \tparam _Digraph The digraph type the algorithm runs on.
   /// The default value is
-  /// \ref ListDigraph. The value of _Digraph is not used directly by
-  /// \ref BfsVisit, it is only passed to \ref BfsVisitDefaultTraits.
-  /// \tparam _Visitor The Visitor type that is used by the algorithm.
-  /// \ref BfsVisitor "BfsVisitor<_Digraph>" is an empty visitor, which
-  /// does not observe the BFS events. If you want to observe the BFS
-  /// events, you should implement your own visitor class.
+  /// \ref ListDigraph. The value of _Digraph is not used directly by Bfs, it
+  /// is only passed to \ref BfsDefaultTraits.
+  /// \tparam _Visitor The Visitor object for the algorithm. The
+  /// \ref BfsVisitor "BfsVisitor<_Digraph>" is an empty Visitor which
+  /// does not observe the Bfs events. If you want to observe the bfs
+  /// events you should implement your own Visitor class.
   /// \tparam _Traits Traits class to set various data types used by the
   /// algorithm. The default traits class is
   /// \ref BfsVisitDefaultTraits "BfsVisitDefaultTraits<_Digraph>".
   /// See \ref BfsVisitDefaultTraits for the documentation of
-  /// a BFS visit traits class.
+  /// a Bfs visit traits class.
 #ifdef DOXYGEN
   template <typename _Digraph, typename _Visitor, typename _Traits>
@@ -1313,19 +1219,28 @@
   template <typename _Digraph = ListDigraph,
             typename _Visitor = BfsVisitor<_Digraph>,
-            typename _Traits = BfsVisitDefaultTraits<_Digraph> >
+            typename _Traits = BfsDefaultTraits<_Digraph> >
 #endif
   class BfsVisit {
   public:
 
-    ///The traits class.
+    /// \brief \ref Exception for uninitialized parameters.
+    ///
+    /// This error represents problems in the initialization
+    /// of the parameters of the algorithms.
+    class UninitializedParameter : public lemon::UninitializedParameter {
+    public:
+      virtual const char* what() const throw()
+      {
+        return "lemon::BfsVisit::UninitializedParameter";
+      }
+    };
+
     typedef _Traits Traits;
 
-    ///The type of the digraph the algorithm runs on.
     typedef typename Traits::Digraph Digraph;
 
-    ///The visitor type used by the algorithm.
     typedef _Visitor Visitor;
 
-    ///The type of the map that indicates which nodes are reached.
+    ///The type of the map indicating which nodes are reached.
     typedef typename Traits::ReachedMap ReachedMap;
 
@@ -1337,11 +1252,11 @@
     typedef typename Digraph::OutArcIt OutArcIt;
 
-    //Pointer to the underlying digraph.
+    /// Pointer to the underlying digraph.
     const Digraph *_digraph;
-    //Pointer to the visitor object.
+    /// Pointer to the visitor object.
     Visitor *_visitor;
-    //Pointer to the map of reached status of the nodes.
+    ///Pointer to the map of reached status of the nodes.
     ReachedMap *_reached;
-    //Indicates if _reached is locally allocated (true) or not.
+    ///Indicates if \ref _reached is locally allocated (\c true) or not.
     bool local_reached;
 
@@ -1349,5 +1264,7 @@
     int _list_front, _list_back;
 
-    //Creates the maps if necessary.
+    /// \brief Creates the maps if necessary.
+    ///
+    /// Creates the maps if necessary.
     void create_maps() {
       if(!_reached) {
@@ -1369,19 +1286,18 @@
     ///@{
     template <class T>
-    struct SetReachedMapTraits : public Traits {
+    struct DefReachedMapTraits : public Traits {
       typedef T ReachedMap;
       static ReachedMap *createReachedMap(const Digraph &digraph) {
-        LEMON_ASSERT(false, "ReachedMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     /// \brief \ref named-templ-param "Named parameter" for setting
-    /// ReachedMap type.
-    ///
-    /// \ref named-templ-param "Named parameter" for setting ReachedMap type.
+    /// ReachedMap type
+    ///
+    /// \ref named-templ-param "Named parameter" for setting ReachedMap type
     template <class T>
-    struct SetReachedMap : public BfsVisit< Digraph, Visitor,
-                                            SetReachedMapTraits<T> > {
-      typedef BfsVisit< Digraph, Visitor, SetReachedMapTraits<T> > Create;
+    struct DefReachedMap : public BfsVisit< Digraph, Visitor,
+                                            DefReachedMapTraits<T> > {
+      typedef BfsVisit< Digraph, Visitor, DefReachedMapTraits<T> > Create;
     };
     ///@}
@@ -1393,6 +1309,7 @@
     /// Constructor.
     ///
-    /// \param digraph The digraph the algorithm runs on.
-    /// \param visitor The visitor object of the algorithm.
+    /// \param digraph the digraph the algorithm will run on.
+    /// \param visitor The visitor of the algorithm.
+    ///
     BfsVisit(const Digraph& digraph, Visitor& visitor)
       : _digraph(&digraph), _visitor(&visitor),
